--
--  @(!--#) @(#) bcform.e, version 015, 15-march-2003
--
--  Basic Character FORMs routines to display character based
--  (24x80 cell) forms for keyboard input and screen output
--

constant BCF_TEXT   = 1
constant BCF_FIELD  = 2
constant BCF_STATUS = 3
constant BCF_FKEY   = 4

constant BCF_SIZE   = 4

constant BCF_STATUS_KEY  = 1

constant BCF_DELETE      = 2000
constant BCF_BEGIN_FIELD = 2001
constant BCF_END_FIELD   = 2002
constant BCF_MOVE_LEFT   = 2003
constant BCF_MOVE_RIGHT  = 2004
constant BCF_NEXT_FIELD  = 2005
constant BCF_PREV_FIELD  = 2006

global constant BCF_FKEY1  = 1001
global constant BCF_FKEY2  = 1002
global constant BCF_FKEY3  = 1003
global constant BCF_FKEY4  = 1004
global constant BCF_FKEY5  = 1005
global constant BCF_FKEY6  = 1006
global constant BCF_FKEY7  = 1007
global constant BCF_FKEY8  = 1008

------------------------------------------------------------------------------

global procedure bcf_displayform(sequence bcf, integer clearscreen)

  sequence t
  sequence ti
  sequence f
  sequence fi
  
  if clearscreen = 1 then
    clear_screen()
  end if
  
  t = bcf[BCF_TEXT]
  
  for i = 1 to length(t) do
    ti = t[i]
    position(ti[1], ti[2])
    printf(1, "%s", {ti[3]})
  end for
  
  f = bcf[BCF_FIELD]
  
  for i = 1 to length(f) do
    fi = f[i]
    position(fi[1], fi[2])
    if fi[6] = ' ' then
      printf(1, "%s", {fi[5]})
    else
      printf(1, "%s", {repeat(fi[6], length(fi[5]))})
    end if
    for j = 1 to (fi[3] - length(fi[5])) do
      printf(1, "_", {})
    end for
  end for
  
end procedure

------------------------------------------------------------------------------

function bcf_wait_key()

  integer  k
  
  while 1 do
    k = wait_key()
    
    if (k >= ' ') and (k <= '~') then
      exit
    end if
    
    if (k = 8) or (k = 127) or (k = 263) or (k = 339) then
      k = BCF_DELETE
      exit
    end if
    
    if (k = 9) or (k = 10) or (k = 13) then
      k = BCF_NEXT_FIELD
      exit
    end if
    
    if (k = 1) then
      k = BCF_BEGIN_FIELD
      exit
    end if
    
    if (k = 2) then
      k = BCF_MOVE_LEFT
      exit
    end if
    
    if (k = 5) then
      k = BCF_END_FIELD
      exit
    end if
    
    if (k = 6) then
      k = BCF_MOVE_RIGHT
      exit
    end if
    
    if (k = 27) then
      k = wait_key()
      
      if (k = -1) then
        k = wait_key()
      end if
      
      if (k = 9) then
        k = BCF_PREV_FIELD
        exit
      end if
      
      if (k = '1') then
        k = BCF_FKEY1
        exit
      end if
      
      if (k = '2') then
        k = BCF_FKEY2
        exit
      end if
      
      if (k = '3') then
        k = BCF_FKEY3
        exit
      end if
      
      if (k = '4') then
        k = BCF_FKEY4
        exit
      end if
      
      if (k = '5') then
        k = BCF_FKEY5
        exit
      end if
      
      if (k = '6') then
        k = BCF_FKEY6
        exit
      end if
      
      if (k = '7') then
        k = BCF_FKEY7
        exit
      end if
      
      if (k = '8') then
        k = BCF_FKEY8
        exit
      end if
      
    end if 
    
    if (k = 315) then
      k = BCF_FKEY1
      exit
    end if
    
    if (k = 316) then
      k = BCF_FKEY2
      exit
    end if
    
    if (k = 317) then
      k = BCF_FKEY3
      exit
    end if
    
    if (k = 318) then
      k = BCF_FKEY4
      exit
    end if
    
    if (k = 319) then
      k = BCF_FKEY5
      exit
    end if
    
    if (k = 320) then
      k = BCF_FKEY6
      exit
    end if
    
    if (k = 321) then
      k = BCF_FKEY7
      exit
    end if
    
    if (k = 322) then
      k = BCF_FKEY8
      exit
    end if
    
    if (k = 331) then
      k = BCF_MOVE_LEFT
      exit
    end if

    if (k = 333) then
      k = BCF_MOVE_RIGHT
      exit
    end if

    if (k = 327) then
      k = BCF_BEGIN_FIELD
      exit
    end if

    if (k = 335) then
      k = BCF_END_FIELD
      exit
    end if
  end while
  
  return(k)

end function

------------------------------------------------------------------------------

function allowable_fkey(integer  key  ,
	                sequence fkey )

  key = key - BCF_FKEY1 + '1'
  
  if find(key, fkey ) then
    return(1)
  else
    return(0)
  end if
  
end function	                

------------------------------------------------------------------------------

function midstring(sequence s, integer b, integer e)

  sequence r
  integer  ls
  
  r = ""
  
  ls = length(s)
  
  if ls >= 1 then
    if (b >= 1) and (b <= ls) then
      if (e >= b) then
        if (e > ls) then
          e = ls
        end if
        
        r = s[b..e]
      end if
    end if
  end if
  
  return(r)
  
end function

------------------------------------------------------------------------------

function bcf_fieldedit( integer  line   ,
	                integer  col    ,
	                integer  width  ,
	                sequence value  ,
	                integer  pwmask ,
	                sequence fkey   )

  integer  l
  integer  c
  integer  k

  l = length(value)
  
  c = l

  position(line, col + c)
  
  while 1 do
    k = bcf_wait_key()
    
    if (k = BCF_NEXT_FIELD) or (k = BCF_PREV_FIELD) then
      exit
    elsif (k >= BCF_FKEY1) and (k <= BCF_FKEY8) then
      if allowable_fkey(k, fkey) then
        exit
      end if
    elsif (k = BCF_MOVE_LEFT) then
      if c > 0 then
        c = c - 1
        position(line, col + c)
      end if
    elsif (k = BCF_MOVE_RIGHT) then
      if c < l then
        c = c + 1
        position(line, col + c)
      end if
    elsif (k = BCF_BEGIN_FIELD) then
      if c != 0 then
        c = 0
        position(line, col + c)
      end if
    elsif (k = BCF_END_FIELD) then
      if c != l then
        c = l
        position(line, col + c)
      end if
    elsif (k = BCF_DELETE) then
      if (l > 0) and (c > 0) then
        if c = l then
          c = c - 1
          position(line, col + c)
          printf(1, "_", {})
          position(line, col + c)
          l = l - 1
          value = midstring(value, 1, l)
        else
          c = c - 1
          position(line, col + c)
          if pwmask = ' ' then
            printf(1, "%s_", {midstring(value, c+2, l)})
          else
            printf(1, "%s_", {repeat(pwmask, length(midstring(value, c+2, l)))})
          end if
          position(line, col + c)
          value = midstring(value, 1, c) & midstring(value, c+2, l)
          l = l - 1
        end if
      end if
    else
      if l < width then
        if pwmask = ' ' then
          printf(1, "%s%s", {k, midstring(value, c+1, l)})
        else
          printf(1, "%s%s", {pwmask, repeat(pwmask, length(midstring(value, c+1, l)))})
        end if
        c = c + 1
        position(line, col + c)
        value = midstring(value, 1, c-1) & {k} & midstring(value, c, l)
        l = l + 1
      end if
    end if
  end while

  return({k, value})
	                   
end function	                   

------------------------------------------------------------------------------

global function bcf_newform()

  --  return a new (empty) basic character form
  
  sequence bcf
  
  bcf = repeat({}, BCF_SIZE)
  
  bcf[BCF_FKEY] = "12345678"
  
  return(bcf)
  
end function

------------------------------------------------------------------------------

global function bcf_allowfkeys( sequence bcf  ,
                                sequence keys )

  bcf[BCF_FKEY] = keys

  return(bcf)

end function

------------------------------------------------------------------------------

global function bcf_addtext( sequence bcf    ,
	                         integer  line   ,
	                         integer  col    ,
	                         sequence text   )

  sequence t
  
  t = bcf[BCF_TEXT]
  
  t = append(t, { line, col, text })
  
  bcf[BCF_TEXT] = t
  
  return(bcf)
  
end function

------------------------------------------------------------------------------

global function bcf_addtext_rj( sequence bcf  ,
                                integer  line ,
                                integer  col  ,
                                sequence text )

  sequence t
  
  t = bcf[BCF_TEXT]
  
  t = append(t, { line, col-length(text)+1, text })
  
  bcf[BCF_TEXT] = t
  
  return(bcf)
  
end function

------------------------------------------------------------------------------

global function bcf_addutext(sequence bcf    ,
                             integer  line   ,
                             integer  col    ,
                             sequence text   ,
                             integer  uchar  )

  sequence utext

  bcf = bcf_addtext(bcf, line, col, text)

  utext = repeat(uchar, length(text))

  bcf = bcf_addtext(bcf, line+1, col, utext)

  return(bcf)

end function

------------------------------------------------------------------------------

global function bcf_addutext_rj( sequence bcf   ,
                                 integer  line  ,
                                 integer  col   ,
                                 sequence text  ,
                                 integer  uchar )

  sequence utext

  bcf = bcf_addtext_rj(bcf, line, col, text)

  utext = repeat(uchar, length(text))

  bcf = bcf_addtext_rj(bcf, line+1, col, utext)

  return(bcf)

end function

------------------------------------------------------------------------------

function bcf_addfield_internal( sequence bcf    ,
	                        integer  line   ,
	                        integer  col    ,
	                        integer  width  ,
	                        sequence name   ,
	                        sequence value  ,
	                        integer  pwmask )

  sequence f
  
  f = bcf[BCF_FIELD]
  
  f = append(f, { line, col, width, name, value, pwmask })
  
  bcf[BCF_FIELD] = f
  
  return(bcf)
  
end function

------------------------------------------------------------------------------

global function bcf_addfield(     sequence bcf    ,
	                          integer  line   ,
	                          integer  col    ,
	                          integer  width  ,
	                          sequence name   ,
	                          sequence value  )

  bcf = bcf_addfield_internal(bcf, line, col, width, name, value, ' ')
  
  return(bcf)
  
end function

------------------------------------------------------------------------------

global function bcf_addfield_pw(  sequence bcf    ,
	                          integer  line   ,
	                          integer  col    ,
	                          integer  width  ,
	                          sequence name   ,
	                          sequence value  ,
	                          integer  pwmask )

  bcf = bcf_addfield_internal(bcf, line, col, width, name, value, pwmask)
  
  return(bcf)
  
end function

------------------------------------------------------------------------------

global function bcf_key(sequence bcf)

  return(bcf[BCF_STATUS][BCF_STATUS_KEY])
  
end function

------------------------------------------------------------------------------

global function bcf_interact(sequence bcf)

  sequence f
  integer  totalf
  integer  cf
  sequence fi
  sequence edit
  integer  k
  
  bcf_displayform(bcf, 1)
  
  f = bcf[BCF_FIELD]
  
  totalf = length(f)

  -- if no field items then return immediately
  if totalf = 0 then
    position(1, 1)
    return(bcf)
  end if

  cf = 1
  
  while 1 do  
    fi = f[cf]
    
    edit = bcf_fieldedit(fi[1], fi[2], fi[3], fi[5], fi[6], bcf[BCF_FKEY])

    k = edit[1]
    fi[5] = edit[2]
    
    f[cf] = fi
    
    if (k = BCF_NEXT_FIELD) then
      cf = cf + 1
      if cf > totalf then
        cf = 1
      end if
    end if
    
    if (k = BCF_PREV_FIELD) then
      cf = cf - 1
      if cf < 1 then
        cf = totalf
      end if
    end if
    
    if (k >= BCF_FKEY1) and (k <= BCF_FKEY8) then
      exit
    end if
  end while
    
  bcf[BCF_FIELD] = f
  
  bcf[BCF_STATUS] = { k }
  
  return(bcf)

end function

------------------------------------------------------------------------------

global function bcf_fieldread( sequence bcf  ,
	                    sequence name )

  sequence f	                    
  sequence value
  
  f = bcf[BCF_FIELD]
    
  value = ""
  
  for i = 1 to length(f) do
    if equal(f[i][4], name) then
      value = f[i][5]
    end if
  end for
  
  return(value)

end function

------------------------------------------------------------------------------

--  end of file
