--
--  navigate.ex
--
--  a medium complexity basic character form
--

include get.e
include dll.e

include bcform.e

--  main code

sequence fname
sequence sname
sequence email
sequence password
sequence bcf
sequence d

fname = ""
sname = ""
email = ""
password = ""

while 1 do
  bcf = bcf_newform()

  bcf = bcf_addutext(bcf, 1, 1, "Personal Details", '=')
  
  d = date()
  
  bcf = bcf_addtext_rj(bcf, 1, 80, sprintf("Time --- %02d:%02d:%02d", {d[4], d[5], d[6]}))
  
  bcf = bcf_addtext(bcf, 4, 1, "First name:")
  bcf = bcf_addfield(bcf, 4, 20, 40, "fname", fname)

  bcf = bcf_addtext(bcf, 5, 1, "Surname:")
  bcf = bcf_addfield(bcf, 5, 20, 40, "sname", sname)

  bcf = bcf_addtext(bcf, 6, 1, "Email address:")
  bcf = bcf_addfield(bcf, 6, 20, 40, "email", email)

  bcf = bcf_addtext(bcf, 7, 1, "Password:")
  bcf = bcf_addfield_pw(bcf, 7, 20, 40, "password", password, '*')

  bcf = bcf_addutext(bcf, 22, 1, "F1=Continue", '-')
  bcf = bcf_addutext(bcf, 22, 35, "F2=Reset", '-')
  bcf = bcf_addutext_rj(bcf, 22, 80, "F8=Exit", '-')
  
  bcf = bcf_allowfkeys(bcf, "128")

  bcf = bcf_interact(bcf)
  
  fname = bcf_fieldread(bcf, "fname")
  sname = bcf_fieldread(bcf, "sname")
  email = bcf_fieldread(bcf, "email")
  password = bcf_fieldread(bcf, "password")

  if bcf_key(bcf) = BCF_FKEY1 then
    exit
  end if

  if bcf_key(bcf) = BCF_FKEY2 then
    fname = ""
    sname = ""
    email = ""
    password = ""
  end if
  
  if bcf_key(bcf) = BCF_FKEY8 then
    clear_screen()
    abort(0)
  end if
end while

bcf = bcf_newform()

bcf = bcf_addtext(bcf, 1, 1, sprintf("Your first name is \"%s\".", {fname}))
bcf = bcf_addtext(bcf, 2, 1, sprintf("Your surname is \"%s\".", {sname}))
bcf = bcf_addtext(bcf, 3, 1, sprintf("Your email address is \"%s\".", {email}))
bcf = bcf_addtext(bcf, 4, 1, sprintf("Your password is \"%s\".", {password}))

bcf = bcf_addtext(bcf, 6, 1, "Press F8 to exit.")

bcf = bcf_addfield(bcf, 24, 1, 0, "dummy", "")

bcf = bcf_allowfkeys(bcf, "8")

bcf = bcf_interact(bcf)

clear_screen()

abort(0)

-- end of file
